"use strict";
var from_dir_1 = require('./from-dir');
var string_builder_1 = require('./string-builder');
var fs = require('fs');
var path = require('path');
exports.build = function (rootPath) {
    var importStatements = new string_builder_1.StringBuilder();
    var content = new string_builder_1.StringBuilder();
    var modules = [];
    try {
        fs.accessSync(path.resolve('node_modules/@angular/animations'));
        importStatements.addLine("import { BrowserAnimationsModule } from '@angular/platform-browser/animations';");
        modules.push('BrowserAnimationsModule');
    }
    catch (e) {
    }
    content.addLine('');
    content.addLine("export const PLAYGROUND_SUPPORT_MODULES: any[] = [" + modules.join(',') + "];");
    var home = path.resolve(rootPath);
    var sandboxCount = 0;
    var sandboxes = [];
    from_dir_1.fromDir(home, /\.sandbox.ts$/, function (filename) {
        var filePathToUse = filename.replace(home, '.').replace(/.ts$/, '').replace(/\\/g, '/');
        var importName = "s" + ++sandboxCount;
        sandboxes.push(importName);
        importStatements.addLine("import { default as " + importName + " } from '" + filePathToUse + "';");
    });
    content.addLine("export let sandboxes: any[] = [];");
    sandboxes.forEach(function (importName) {
        content.addLine("sandboxes.push(" + importName + ".serialize());");
    });
    var filePath = path.resolve(home, './sandboxes.ts');
    fs.writeFile(filePath, importStatements.dump() + content.dump(), function (err) {
        if (err) {
            return console.log(err);
        }
        console.log("Created file: " + filePath);
    });
};
